
set slaves(buck) "IrcNet.Ru 1 0"
set slaves(zoidby) "DalNet.Ru 1 0"
set slaves(magician) "Wenet 1 0"

bind    bot     -   slave   bots:slavecommand

proc mc:stripbadcodes {text} {
    regsub -all \\\\ $text "\\\\\\\\" text
    regsub -all \\\[ $text "\\\[" text
    regsub -all \\\] $text "\\\]" text
    regsub -all \\\^ $text "\\\^" text
    
    return $text
}

proc mc:saybots {n uh h t} {       
    bots:say $n [join [lrange $t 1 end]]
}

proc bots:say {who message} {
    global slaves
    
    mc:say "(global) 12$who10: $message"
}

proc bots:moderate {} {
    global mc slaves
    
    pushmode $mc(chan) +m
    foreach slave [array names slaves] {
        if {[islinked $slave]} {
           putbot $slave "eval pushmode #&chan +m"
        }
    }
}

proc bots:unmoderate {} {
    global mc slaves
    
    pushmode $mc(chan) -m
    foreach slave [array names slaves] {
        if {[islinked $slave]} {
           putbot $slave "eval pushmode #&chan -m"
        }
    }
}

proc bots:op {nick} {
    global mc slaves
    
    if {![string match "*@*" $nick]} {
        pushmode $mc(chan) +o [ms:dfl $nick]
    } else {
        set truenick [lindex [split $nick "@"] 0]
        foreach slave [array names slaves] {            
            if {[string tolower [lindex $slaves($slave) 0]] == [string tolower [lindex [split $nick "@"] 1]] && [islinked $slave]} {                
                putbot $slave "trueeval if {!\[isop $truenick #&chan\] && \[info exists wasdeoped($truenick)\]} { pushmode #&chan +o $truenick; unset wasdeoped($truenick) }"
            }
        }
    }
}

proc bots:deop {nick} {
    global mc slaves
    
    if {![string match "*@*" $nick]} {
        pushmode $mc(chan) -o [ms:dfl $nick]
    } else {
        set truenick [lindex [split $nick "@"] 0]
        foreach slave [array names slaves] {            
            if {[string tolower [lindex $slaves($slave) 0]] == [string tolower [lindex [split $nick "@"] 1]] && [islinked $slave]} {                
                putbot $slave "trueeval if {\[isop $truenick #&chan\]} { pushmode #&chan -o $truenick; set wasdeoped($truenick) 1 }"
            }
        }
    }
}

proc bots:voice {nick} {
    global mc slaves
    
    if {![string match "*@*" $nick]} {
        pushmode $mc(chan) +v [ms:dfl $nick]
    } else {
        set truenick [lindex [split $nick "@"] 0]
        foreach slave [array names slaves] {            
            if {[string tolower [lindex $slaves($slave) 0]] == [string tolower [lindex [split $nick "@"] 1]] && [islinked $slave]} {                
                putbot $slave "eval pushmode #&chan +v $truenick"
            }
        }
    }
}

proc bots:devoice {nick} {
    global mc slaves
    
    if {![string match "*@*" $nick]} {
        pushmode $mc(chan) -v [ms:dfl $nick]
    } else {
        set truenick [lindex [split $nick "@"] 0]
        foreach slave [array names slaves] {            
            if {[string tolower [lindex $slaves($slave) 0]] == [string tolower [lindex [split $nick "@"] 1]] && [islinked $slave]} {                
                putbot $slave "eval pushmode #&chan -v $truenick"
            }
        }
    }
}

proc bots:messageslavequick {botname who msg} {
    global slaves mc

    regsub -all "" $msg "!9" msgfixed
    regsub -all "" $who "!9" whofixed
    if {[string match "#*" $who]} {
        foreach slave [array names slaves] {
            if {[islinked $slave]} {
                putbot $slave "eval putquick \"PRIVMSG #&chan :$msgfixed\""
            }
        }
        if {$botname == $mc(chan)} {
            mc:putslave rawcmd_fast "PRIVMSG $mc(chan) :$msg"
        } else {
            putquick "PRIVMSG $mc(chan) :$msg"
        }
    } else {
        if {[islinked $botname]} {
            putbot $botname "eval putquick \"PRIVMSG $whofixed :$msgfixed\""
        }
    }
}

proc bots:messageslaveserv {botname who msg} {
    global slaves mc

    regsub -all "" $msg "!9" msgfixed
    regsub -all "" $who "!9" whofixed
    if {[string match "#*" $who]} {
        foreach slave [array names slaves] {
            if {[islinked $slave]} {
                putbot $slave "eval putserv \"PRIVMSG #&chan :$msgfixed\""
            }
        }
        if {$botname == $mc(chan)} {
            mc:putslave rawcmd "PRIVMSG $mc(chan) :$msg"
        } else {
            putserv "PRIVMSG $mc(chan) :$msg"
        }        
    } else {
        if {[islinked $botname]} {
            putbot $botname "eval putserv \"PRIVMSG $whofixed :$msgfixed\""
        }
    }
}

proc bots:messageslavehelp {botname who msg} {
    global slaves mc

    regsub -all "" $msg "!9" msgfixed
    regsub -all "" $who "!9" whofixed
    if {[string match "#*" $who]} {
        foreach slave [array names slaves] {
            if {[islinked $slave]} {
                putbot $slave "eval puthelp \"PRIVMSG #&chan :$msgfixed\""
            }
        }
        if {$botname == $mc(chan)} {
            mc:putslave rawcmd_slow "PRIVMSG $mc(chan) :$msg"
        } else {
            puthelp "PRIVMSG $mc(chan) :$msg"
        }                
    } else {
        if {[islinked $botname]} {
            putbot $botname "eval puthelp \"PRIVMSG $whofixed :$msgfixed\""
        }
    }
}

proc bots:slavecommand {botname command arguments} {
    global slaves mc

    regsub -all "!9" $arguments "" arguments
    if {[lsearch -exact [array names slaves] $botname] != -1} {
        set arguments [lreplace $arguments 1 1 "[lindex $arguments 1]@[lindex $slaves($botname) 0]"]
        foreach ee [binds "*mc:*"] {
            if {[string tolower [lindex $ee 0]] == [string tolower [lindex $arguments 0]]} {
                if {[string tolower [lindex $arguments 0]] == "pubm"} {
                    set rights [split [lindex $ee 1] "|"]
                    if {[string match [lindex $ee 2] "$mc(chan) [join [lrange $arguments 5 end]]"] == 1} {
                        if {[lindex $rights 0] != "-" || [lindex $rights 1] != "-"} {
                            continue
                        }
                        eval "[lindex $ee 4] \"[mc:stripbadcodes [lindex $arguments 1]]\" \"[mc:stripbadcodes [lindex $arguments 2]]\" \"[mc:stripbadcodes [lindex $arguments 3]]\" \"[mc:stripbadcodes [lindex $arguments 4]]\" \"[mc:stripbadcodes [join [lrange $arguments 5 end]]]\""
                    }
                } elseif {[string tolower [lindex $arguments 0]] == "msgm"} {
                    set rights [split [lindex $ee 1] "|"]
                    if {[string match [lindex $ee 2] [join [lrange $arguments 4 end]]] == 1} {
                        if {[lindex $rights 0] != "-" || [lindex $rights 1] != "-"} {
                            continue
                        }                        
                        eval "[lindex $ee 4] \"[mc:stripbadcodes [lindex $arguments 1]]\" \"[mc:stripbadcodes [lindex $arguments 2]]\" \"[mc:stripbadcodes [lindex $arguments 3]]\" \"[mc:stripbadcodes [join [lrange $arguments 4 end]]]\""
                    }
                } elseif {[string tolower [lindex $arguments 0]] == "notc"} {
                    if {[string match [lindex $ee 2] [join [lrange $arguments 4 end]]] == 1} {
                        eval "[lindex $ee 4] \"[mc:stripbadcodes [lindex $arguments 1]]\" \"[mc:stripbadcodes [lindex $arguments 2]]\" \"[mc:stripbadcodes [lindex $arguments 3]]\" \"[mc:stripbadcodes [lindex $arguments 4]]\" \"[mc:stripbadcodes [lindex $arguments 5]]\""
                    }
                } elseif {[string tolower [lindex $arguments 0]] == "join"} {
                    eval "[lindex $ee 4] \"[mc:stripbadcodes [lindex $arguments 1]]\" \"[mc:stripbadcodes [lindex $arguments 2]]\" \"[mc:stripbadcodes [lindex $arguments 3]]\" \"[mc:stripbadcodes [lindex $arguments 4]]\""
                } elseif {[string tolower [lindex $arguments 0]] == "part"} {
                    eval "[lindex $ee 4] \"[mc:stripbadcodes [lindex $arguments 1]]\" \"[mc:stripbadcodes [lindex $arguments 2]]\" \"[mc:stripbadcodes [lindex $arguments 3]]\" \"[mc:stripbadcodes [lindex $arguments 4]]\" \"[mc:stripbadcodes [lindex $arguments 5]]\""
                } elseif {[string tolower [lindex $arguments 0]] == "sign"} {
                    eval "[lindex $ee 4] \"[mc:stripbadcodes [lindex $arguments 1]]\" \"[mc:stripbadcodes [lindex $arguments 2]]\" \"[mc:stripbadcodes [lindex $arguments 3]]\" \"[mc:stripbadcodes [lindex $arguments 4]]\" \"[mc:stripbadcodes [lindex $arguments 5]]\""
                } elseif {[string tolower [lindex $arguments 0]] == "kick"} {
                    eval "[lindex $ee 4] \"[mc:stripbadcodes [lindex $arguments 1]]\" \"[mc:stripbadcodes [lindex $arguments 2]]\" \"[mc:stripbadcodes [lindex $arguments 3]]\" \"[mc:stripbadcodes [lindex $arguments 4]]\" \"[mc:stripbadcodes [lindex $arguments 5]]\" \"[mc:stripbadcodes [lindex $arguments 6]]\""
                } elseif {[string tolower [lindex $arguments 0]] == "nick"} {
                    eval "[lindex $ee 4] \"[mc:stripbadcodes [lindex $arguments 1]]\" \"[mc:stripbadcodes [lindex $arguments 2]]\" \"[mc:stripbadcodes [lindex $arguments 3]]\" \"[mc:stripbadcodes [lindex $arguments 4]]\" \"[mc:stripbadcodes [lindex $arguments 5]]\""
                } elseif {[string tolower [lindex $arguments 0]] == "splt"} {
                    eval "[lindex $ee 4] \"[mc:stripbadcodes [lindex $arguments 1]]\" \"[mc:stripbadcodes [lindex $arguments 2]]\" \"[mc:stripbadcodes [lindex $arguments 3]]\" \"[mc:stripbadcodes [lindex $arguments 4]]\""
                } elseif {[string tolower [lindex $arguments 0]] == "rejn"} {
                    eval "[lindex $ee 4] \"[mc:stripbadcodes [lindex $arguments 1]]\" \"[mc:stripbadcodes [lindex $arguments 2]]\" \"[mc:stripbadcodes [lindex $arguments 3]]\" \"[mc:stripbadcodes [lindex $arguments 4]]\""
                }
            }
        }
    }
}
