# 0 - comname
# 1 - user list {nick access}
# 2 - games num
# 3 - win num
# 4 - 1/0 - private/public
# 5 - 1/0 -  
# 6 - max players
# 7 - 1/0 - / 
# 8 - 
# 9 - 
# 10 - 1/0 -    / 
# 11 - 
# 12 - 1/0 - / 
# 13 - taxrate
# 14 -  
# 15 -   

proc mc:comid {c} {
  regsub -all "(\[1234567890\]*)(,\[1234567890\]*)?" $c "" c
  regsub -all "\[<>-\]" $c "" c
  regsub -all "\[\[:space:\]\]" $c "" c
  regsub -all \\\[ $c "" c
  regsub -all \\\] $c "" c
  regsub -all \\\{ $c "" c
  regsub -all \\\} $c "" c
  regsub -all \\\^ $c "" c
  regsub -all \\\" $c "" c
  regsub -all \\\\ $c "" c
  set c [tolower $c]
  return $c
}

proc mc:comga {cid id} {
  global mco

  set acc 0
  foreach nn [mc:mcomget $cid 1] {
    if {[lindex $nn 0] == $id} {
      set acc [lindex $nn 1]
    }
  }
  return $acc
}

proc mc:comreg {id c1 c2} {
  global mco mcs cto mc

  if {$c2 != ""} {
    set c1 "$c1 $c2"
  }
  set nni [ms:dfl [mc:modget $id 0]]
  #     .NNN
  if {[regexp -all -nocase "^.\[0-9\]+$" $c1]} {
    mc:msg $nni $cto(3)
    return
  }
  set cid [mc:comid $c1]
  if {$cid == ""} {
    mc:msg $nni $cto(0)
    return
  }
  if {[info exist mco($cid)]} {
    mc:msg $nni $cto(1)
    return
  }
  set mco($cid) "{[ms:fl $c1]} {{$id 100}} 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0"
  mc:notice $mc(notchan) "command_register: [ms:dfl $id] $cid $c1"
  mc:msg $nni [format $cto(2) $cid $c1]
}

proc mc:comname {id c1 c2} {
  global mco mcs cto
  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {$c2 == ""} {
    mc:msg $nni $cto(11)
    return
  }
  if {[mc:comga $cid $id] != 100} {
    mc:msg $nni $cto(12)
    return
  }
  if {[mc:comid $c2] != $cid} {
    mc:msg $nni $cto(13)
    return
  }
  mc:mcomset $cid 0 "$c2"
  mc:msg $nni [format $cto(14) $c2]
}

proc mc:comdrop {id c1 c2} {
  global mco mcs cto mc

  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]
  
  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {$c1 == ""} {
    mc:msg $nni $cto(17)
    return
  }
  if {[mc:comga $cid $id] != 100} {
    mc:msg $nni $cto(12)
    return
  }
  mc:msg $nni [format $cto(18) [mc:mcomget $cid 0]]
  mc:notice $mc(notchan) "command_drop: [ms:dfl $id] $cid [mc:mcomget $cid 0]"
  unset mco($cid)
}

proc mc:compub {id c1 c2} {
  global mco mcs cto

  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {$c2 == ""} {
    mc:msg $nni $cto(15)
    return
  }
  if {[mc:comga $cid $id] != 100} {
    mc:msg $nni $cto(12)
    return
  }
  if {$c2 == 0} {
    mc:mcomset $cid 4 1
    mc:msg $nni [format $cto(16) [mc:mcomget $cid 0]]
  } else {
    mc:mcomset $cid 4 0
    mc:msg $nni [format $cto(16a) [mc:mcomget $cid 0]]
  }
}

proc mc:commax {id c1 c2} {
  global mco mcs cto
  
  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {$c2 == ""} {
    mc:msg $nni $cto(21)
    return
  }
  if {[mc:comga $cid $id] != 100} {
    mc:msg $nni $cto(12)
    return
  }
  if {[isnumber $c2] && $c2 > 0} {
    mc:mcomset $cid 6 $c2
    mc:msg $nni [format $cto(21b) [mc:mcomget $cid 0] $c2]
  } elseif {$c2 == 0} {
    mc:mcomset $cid 6 0
    mc:msg $nni [format $cto(21a) [mc:mcomget $cid 0]]
  } else {
    mc:msg $nni $cto(21)
  }
}

proc mc:comchn {id c1 c2} {
  global mco mcs cto
  
  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {$c2 == ""} {
    mc:msg $nni $cto(19)
    return
  }
  if {[mc:comga $cid $id] < 90} {
    mc:msg $nni $cto(12)
    return
  }
  if {$c2 == 0} {
    mc:mcomset $cid 5 1
    mc:msg $nni [format $cto(20a) [mc:mcomget $cid 0]]
  } else {
    mc:mcomset $cid 5 0
    mc:msg $nni [format $cto(20) [mc:mcomget $cid 0]]
  }
}

proc mc:comclan {id c1 c2} {
  global mco mcs cto mc
  
  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {$c2 == ""} {
    mc:msg $nni $cto(22)
    return
  }
  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {[mc:comga $cid $id] != 100} {
    mc:msg $nni $cto(12)
    return
  }
  if {[mc:mcomget $cid 7] == $c2} {
     if {$c2 == 0} {
        mc:msg $nni [format $cto(22f) [mc:mcomget $cid 0]]
     } else {
        mc:msg $nni [format $cto(22e) [mc:mcomget $cid 0]]
     }
     return
  }
  if {$c2 == 0} {
    mc:mcomset $cid 7 0
    mc:msg $nni [format $cto(22a) [mc:mcomget $cid 0]]
  } else {
    if {[mc:modget $id 11] < 1500} {
       mc:msg $nni $cto(22c)
       return
    }
    mc:mod $id 11 -1500
    mc:mcomset $cid 7 1
    #  
    mc:mcomset $cid 8 0
    mc:mcomset $cid 9 0
    mc:mcomset $cid 10 1
    mc:mcomset $cid 11 0
    mc:mcomset $cid 12 0
    mc:mcomset $cid 13 0
    mc:mcomset $cid 14 0

    mc:msg $nni $cto(22d)
    mc:msg $nni [format $cto(22b) [mc:mcomget $cid 0]]
    mc:notice $mc(notchan) "command_clan: [ms:dfl $id] $cid [mc:mcomget $cid 0]"
  }
}

proc mc:comdesc {id c1 c2} {
  global mco mcs cto
  
  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {$c2 == ""} {
    mc:msg $nni $cto(23)
    return
  }
  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {[mc:mcomget $cid 7] != 1} {
    mc:msg $nni [format $cto(23d) [mc:mcomget $cid 0]]
    return
  }
  if {[mc:comga $cid $id] != 100} {
    mc:msg $nni $cto(12)
    return
  }
  if {[string length $c2] > 200} {
    mc:msg $nni $cto(23c)
    return
  }
  if {$c2 == 0} {
    mc:mcomset $cid 8 0
    mc:msg $nni [format $cto(23a) [mc:mcomget $cid 0]]
  } else {
    mc:mcomset $cid 8 "[string trim $c2]"
    mc:msg $nni [format $cto(23b) [mc:mcomget $cid 0] [mc:mcomget $cid 8]]
  }
}

proc mc:comrules {id c1 c2} {
  global mco mcs cto
  
  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {$c2 == ""} {
    mc:msg $nni $cto(24)
    return
  }
  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {[mc:mcomget $cid 7] != 1} {
    mc:msg $nni [format $cto(23d) [mc:mcomget $cid 0]]
    return
  }
  if {[mc:comga $cid $id] != 100} {
    mc:msg $nni $cto(12)
    return
  }
  if {[string length $c2] > 300} {
    mc:msg $nni $cto(23c)
    return
  }
  if {$c2 == 0} {
    mc:mcomset $cid 9 0
    mc:msg $nni [format $cto(24a) [mc:mcomget $cid 0]]
  } else {
    mc:mcomset $cid 9 "[string trim $c2]"
    mc:msg $nni [format $cto(24b) [mc:mcomget $cid 0] [mc:mcomget $cid 9]]
  }
}

proc mc:compinf {id c1 c2} {
  global mco mcs cto
  
  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {$c2 == ""} {
    mc:msg $nni $cto(25)
    return
  }
  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {[mc:mcomget $cid 7] != 1} {
    mc:msg $nni [format $cto(23d) [mc:mcomget $cid 0]]
    return
  }
  if {[mc:comga $cid $id] != 100} {
    mc:msg $nni $cto(12)
    return
  }
  if {$c2 == 0} {
    mc:mcomset $cid 10 0
    mc:msg $nni [format $cto(25a) [mc:mcomget $cid 0]]
  } else {
    mc:mcomset $cid 10 1
    mc:msg $nni [format $cto(25b) [mc:mcomget $cid 0]]
  }
}

proc mc:comtax {id c1 c2} {
  global mco mcs cto
  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {$c2 == ""} {
    mc:msg $nni $cto(26)
    return
  }
  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {[mc:mcomget $cid 7] != 1} {
    mc:msg $nni [format $cto(23d) [mc:mcomget $cid 0]]
    return
  }
  if {[mc:comga $cid $id] < 99} {
    mc:msg $nni $cto(12)
    return
  }
  if {$c2 == 0} {
    mc:mcomset $cid 12 0
    mc:msg $nni [format $cto(26a) [mc:mcomget $cid 0]]
  } else {
    mc:mcomset $cid 12 1
    mc:msg $nni [format $cto(26b) [mc:mcomget $cid 0]]
  }
}

proc mc:comtaxrate {id c1 c2} {
  global mco mcs cto
  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {$c2 == ""} {
    mc:msg $nni $cto(27)
    return
  }
  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {[mc:mcomget $cid 7] != 1} {
    mc:msg $nni [format $cto(23d) [mc:mcomget $cid 0]]
    return
  }
  if {![isnumber $c2] || $c2 < 0} {
    mc:msg $nni $cto(27)
    return
  }
  if {[mc:comga $cid $id] < 99} {
    mc:msg $nni $cto(12)
    return
  }
  if {$c2 == 0} {
    mc:mcomset $cid 13 0
    mc:msg $nni [format $cto(27b) [mc:mcomget $cid 0]]
  } else {
    mc:mcomset $cid 13 $c2
    mc:msg $nni [format $cto(27a) [mc:mcomget $cid 0] $c2]
  }
}

proc mc:combank {id c1 c2} {
  global mco mcs cto mc
  
  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {$c1 == ""} {
    mc:msg $nni $cto(28)
    return
  }
  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {[mc:mcomget $cid 7] != 1} {
    mc:msg $nni [format $cto(23d) [mc:mcomget $cid 0]]
    return
  }
  if {[mc:comga $cid $id] < 1} {
    mc:msg $nni [format $cto(28b) [mc:mcomget $cid 0]]
    return
  }
  mc:msg $nni [format $cto(28a) [mc:mcomget $cid 0] [mc:mcomget $cid 11]]
  mc:notice $mc(notchan) "command_bank: [ms:dfl $id] [mc:mcomget $cid 0] ([mc:mcomget $cid 11])"
}

proc mc:comput {id c1 c2} {
  global mco mcs cto
  global mc cth

  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {[mc:modget $id 17] < 2 && [mc:modget $id 30] == 0} {
      mc:msg $nni $cth(75a)
      return
  }
  if {$c2 == ""} {
    mc:msg $nni $cto(29)
    return
  }
  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {[mc:mcomget $cid 7] != 1} {
    mc:msg $nni [format $cto(23d) [mc:mcomget $cid 0]]
    return
  }
  if {![isnumber $c2] || $c2 <= 0 || $c2 > [mc:modget $id 11]} {
    mc:msg $nni $cto(29b)
    return
  }
  mc:mcomset $cid 11 [expr [mc:mcomget $cid 11] + $c2]
  mc:mod $id 11 "-$c2"
  mc:msg $nni [format $cto(29a) $c2 [mc:mcomget $cid 0] [mc:mcomget $cid 11]]
  mc:notice $mc(notchan) "command_put: [ms:dfl $id] [mc:mcomget $cid 0] $c2 ([mc:mcomget $cid 11])"
}

proc mc:comtake {id c1 c2} {
  global mco mcs cto mc
  
  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {$c2 == ""} {
    mc:msg $nni $cto(30)
    return
  }
  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {[mc:mcomget $cid 7] != 1} {
    mc:msg $nni [format $cto(23d) [mc:mcomget $cid 0]]
    return
  }
  if {![isnumber $c2] || $c2 <= 0 || $c2 > [mc:mcomget $cid 11]} {
    mc:msg $nni $cto(30b)
    return
  }
  if {[mc:comga $cid $id] < 99} {
    mc:msg $nni $cto(30c)
    return
  }
  mc:mcomset $cid 11 [expr [mc:mcomget $cid 11] - $c2]
  mc:mod $id 11 "+$c2"
  mc:msg $nni [format $cto(30a) $c2 [mc:mcomget $cid 0] [mc:mcomget $cid 11]]
  mc:notice $mc(notchan) "command_take: [ms:dfl $id] [mc:mcomget $cid 0] $c2 ([mc:mcomget $cid 11])"
}

proc mc:comadd {id c1 c2} {
  global mco mcs cto
  
  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {$c2 == ""} {
    mc:msg $nni $cto(4)
    return
  }
  set id2 [tolower [ms:fl [lindex $c2 0]]]
  if {![info exist mcs($id2)]} {
    mc:msg $nni $cto(5)
    return
  }
  set acc -1
  set acc2 -1
  set exx 0  
  foreach nn [mc:mcomget $cid 1] {
    if {[lindex $nn 0] == $id} {
      set acc [lindex $nn 1]
    }
    if {[lindex $nn 0] == $id2} {
      set acc2 [lindex $nn 1]
      set exx 1
    }
  }
  if {$acc < 99} {
    mc:msg $nni $cto(6)
    return
  }
  if {$acc2 > $acc} {
    mc:msg $nni [format $cto(7) [ms:dfl [mc:modget $id2 0]]]
    return
  }
  if {[llength $c2] > 1} {
    set nlev [lindex $c2 1]
  } else {
    set nlev 1
  }
  if {((![isnumber $nlev]) || ($nlev < 0) || ($nlev >= $acc))&&($nlev != -1)} {
    mc:msg $nni $cto(8)
    return
  }
  set nnn ""
  if {$exx == 1} {
    foreach nn [mc:mcomget $cid 1] {
      if {[lindex $nn 0] == $id2} {
        set nnn [lappend nnn "$id2 $nlev"]
      } else {
        set nnn [lappend nnn $nn]
      }
    }
  } else {
    set nnn [mc:mcomget $cid 1]
    set nnn [lappend nnn "$id2 $nlev"]
  }
  mc:mcomset $cid 1 $nnn
  mc:msg $nni [format $cto(9) [ms:dfl [mc:mcomget $cid 0]] [ms:dfl [mc:modget $id2 0]] $nlev]
}

proc mc:comdel {id c1 c2} {
  global mco mcs cto
  
  set cid [mc:comid $c1]
  set nnd [tolower [ms:fl [lindex $c2 0]]]
  set nni [ms:dfl [mc:modget $id 0]]
  
  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  if {$c2 == ""} {
    mc:msg $nni $cto(4d)
    return
  }
  set id2 [tolower [ms:fl [lindex $c2 0]]]
  set acc -1
  set acc2 -1
  set exx 0
  foreach nn [mc:mcomget $cid 1] {
    if {[lindex $nn 0] == $id} {
      set acc [lindex $nn 1]
    }
    if {[lindex $nn 0] == $id2} {
      set acc2 [lindex $nn 1]
      set exx 1
    }
  }
  if {$acc < 99} {
    mc:msg $nni $cto(6)
    return
  }
  if {$acc2 >= $acc} {
    mc:msg $nni [format $cto(7) [ms:dfl [mc:modget $id2 0]]]
    return
  }
  if {[llength $c2] > 1} {
    set nlev [lindex $c2 1]
  } else {
    set nlev 1
  }
  if {(![isnumber $nlev] || $nlev < 0 || $nlev >= $acc) && $nlev != -1} {
    mc:msg $nni $cto(8)
    return
  }
  if {$nni == $nnd} {
    mc:msg $nni $cto(8d)
    return
  }
  set nnn ""
  if {$exx == 1} {
      foreach nn [mc:mcomget $cid 1] {
          if {[lindex $nn 0] != $nnd} {
              set nnn [lappend nnn $nn]
          } else {
              mc:msg $nni [format $cto(31a) [lindex $c2 0] $c1]
          }
      }
      mc:mcomset $cid 1 $nnn
  }  
}

proc mc:comlist {id c1 c2} {
  global mco mcs cto
  
  set cid [mc:comid $c1]
  set nni [ms:dfl [mc:modget $id 0]]

  if {![info exist mco($cid)]} {
    mc:msg $nni $cto(3)
    return
  }
  set nnn ""
  foreach nn [mc:mcomget $cid 1] {
    if {[info exist mcs([lindex $nn 0])]} {
      set tadd [format $cto(10a) [mc:modget [lindex $nn 0] 0] [lindex $nn 1]]
      if {[expr [string length $nnn] + [string length $tadd]]>400} {
         mc:msg $nni [format $cto(10) [ms:dfl [mc:mcomget $cid 0]] [ms:dfl [join $nnn ", "]]]
         set nnn ""
      }
      set nnn [lappend nnn $tadd]
    }
  }
  mc:msg $nni [format $cto(10) [ms:dfl [mc:mcomget $cid 0]] [ms:dfl [join $nnn ", "]]]
}

proc mc:comset {n uh h t} {
  global mco mcs cto
  
  set id [tolower [ms:fl $n]]
  
  if {![mc:check $id -]} {return}
  if {[llength $t] < 2} {
    return
  } elseif {[llength $t] == 2} {
    set cp1 ""
    set cp2 ""
  } elseif {[llength $t] == 3} {
    set cp1 [lindex $t 2]
    set cp2 ""
  } else {
    set cp1 [lindex $t 2]
    set cp2 [lrange $t 3 end]
  }
  if {$cp1 == "-"} {
    set cp1 [mc:modget $id 2]
  }
  switch [lindex $t 1] {
    reg  { mc:comreg $id $cp1 $cp2 }
    add  { mc:comadd $id $cp1 $cp2 }
    del  { mc:comdel $id $cp1 $cp2 }
    lev  { mc:comadd $id $cp1 $cp2 }
    list { mc:comlist $id $cp1 $cp2 }
    name { mc:comname $id $cp1 $cp2 }
    pub  { mc:compub $id $cp1 $cp2 }
    chn  { mc:comchn $id $cp1 $cp2 }
    max  { mc:commax $id $cp1 $cp2 }
    drop { mc:comdrop $id $cp1 $cp2 }
    clan { mc:comclan $id $cp1 $cp2 }
    desc { mc:comdesc $id $cp1 $cp2 }
    rules { mc:comrules $id $cp1 $cp2 }
    pinf { mc:compinf $id $cp1 $cp2 }
    tax { mc:comtax $id $cp1 $cp2 }
    taxrate { mc:comtaxrate $id $cp1 $cp2 }
    bank { mc:combank $id $cp1 $cp2 }
    put { mc:comput $id $cp1 $cp2 }
    take { mc:comtake $id $cp1 $cp2 }
  }
}
