#  
proc mc:pollopen {n uh h t} {
    global poll cth mc pollanswers announcedur mcs
    
    if {[info exists poll] && [lindex $poll 0] != ""} {
        mc:msg $n [format $cth(82ha) [ms:dfl [lindex $poll 0]]]
        return
    }
    set t [split $t]
    if {[llength $t] < 6} {
        mc:msg $n $cth(82hb)
        mc:msg $n $cth(82hba)
        return        
    }
    set polldur [lindex $t 2]
    if {![isnumber $polldur] || $polldur < 1} {
        set polldur 10
    }
    set polltype [lindex $t 3]
    if {![isnumber $polltype] || ($polltype != 1 && $polltype != 2)} {
        set polltype 1
    }
    set _polllevels [split [lindex $t 4] ""]
    set polllevels ""
    foreach polllevel $_polllevels {
        if {[isnumber $polllevel] && $polllevel > -1 && $polllevel < 10 && [lsearch -exact $polllevels $polllevel] == -1} {
            if {$polllevel == 0 && [lsearch -exact $polllevels 10] == -1} {
               set polllevels [lappend polllevels 10]
            } elseif {$polllevel != 0} {
               set polllevels [lappend polllevels $polllevel]
            }
        }
    }
    set polllevels [lsort -integer -increasing $polllevels]
    if {$polllevels == ""} { set polllevels "{1 2 3 4 5 6 7 8 9 10}" }
	set t [split $t]
	regsub -all \\\[ $t "" t
	regsub -all \\\] $t "" t
	regsub -all \\\{ $t "" t
	regsub -all \\\} $t "" t
	regsub -all \\\^ $t "" t
	regsub -all \\\" $t "'" t
	regsub -all \\\\ $t "/" t
    set polltitle [string trim [join [lrange [ms:fl $t] 5 end]]]
    #  
    if {[info exists poll]} { unset poll }
    if {[array exists pollanswers]} { unset pollanswers }
    set pollanswers(0) ""
    set poll ""
    set poll [lappend poll $polltitle $polltype $polllevels [clock seconds]]
    foreach e [utimers] {
       if {[string match "*mc:pollcloseauto*" $e] || [string match "*mc:pollanounce*" $e]} {
          killutimer [lindex $e 2]
       }
    }    
    mc:msg $n [format $cth(82hc) [ms:dfl $polltitle]]
    if {[llength $polllevels] == 10} {
      mc:msg $n [format $cth(82hd) $polltype ""]
    } elseif {[llength $polllevels] > 6} {
      set except_levels ""
      foreach single_number "1 2 3 4 5 6 7 8 9 10" {
          if {[lsearch -exact $polllevels $single_number] == -1} {
              set except_levels [lappend except_levels $single_number]
          }
      }
      mc:msg $n [format $cth(82hd_) $polltype [join $except_levels]]
    } else {
      mc:msg $n [format $cth(82hd) $polltype [join $polllevels]]
    }
    set id [tolower [ms:fl $n]]
    if {[info exists mcs($id)]} {
      mc:notice $mc(chan) [xformat2 $cth(82he) "{[mc:modget $id 21]}" "$n {[stripspec [ms:dfl $polltitle]]}"]
    } else {
      mc:notice $mc(chan) [format $cth(82he_) $n [ms:dfl $polltitle]]
    }
    if {[llength $polllevels] == 10} {
      mc:notice $mc(chan) [format $cth(82hf) ""]
    } elseif {[llength $polllevels] > 6} {
      set except_levels ""
      foreach single_number "1 2 3 4 5 6 7 8 9 10" {
          if {[lsearch -exact $polllevels $single_number] == -1} {
              set except_levels [lappend except_levels $single_number]
          }
      }           
      mc:notice $mc(chan) [format $cth(82hf_) [join $except_levels]]
    } else {
      mc:notice $mc(chan) [format $cth(82hf) [join $polllevels]]
    }
    if {$polldur > 60} {
        set announcedur 500
    } elseif {$polldur > 30} {
        set announcedur 300
    } elseif {$polldur > 10} {
        set announcedur 200
    } else {
        set announcedur 150
    }
    utimer $announcedur { mc:pollanounce }
    utimer [expr $polldur * 60] { mc:pollcloseauto }
}

#   
proc mc:pollcloseauto {} {
    global poll pollanswers

    foreach e [utimers] {
       if {[string match "*mc:pollcloseauto*" $e] || [string match "*mc:pollanounce*" $e]} {
          killutimer [lindex $e 2]
       }
    }
    if {![info exists poll] || ![array exists pollanswers]} {
        return
    }
    mc:pollresults    
    unset pollanswers
    unset poll
}

#  
proc mc:pollclose {n uh h t} {
    global poll cth mc pollanswers mcs

    if {![info exists poll]} {
        mc:msg $n $cth(82hg)
        return
    }
    set polltitle [ms:dfl [lindex $poll 0]]
    mc:msg $n [format $cth(82hh) $polltitle]
    set id [tolower [ms:dfl $n]]
    if {[info exists mcs($id)]} {
        mc:notice $mc(chan) [xformat2 $cth(82hea) "{[mc:modget $id 21]}" "$n {[stripspec [ms:dfl $polltitle]]}"]   
    } else {
        mc:notice $mc(chan) [format $cth(82hea_) $n [ms:dfl $polltitle]]   
    }    
    mc:pollresults    
    if {[array exists pollanswers]} { unset pollanswers }
    unset poll
    foreach e [utimers] {
       if {[string match "*mc:pollcloseauto*" $e] || [string match "*mc:pollanounce*" $e]} {
          killutimer [lindex $e 2]
       }
    }
}

#  ;]
proc mc:pollvote {n uh h t} {
    global poll cth mc
    global pollanswers

    set id [tolower [ms:fl $n]]
    if {![mc:check $id -]} { return }
    
    if {![info exists poll] || [lindex $poll 0] == ""} {
        mc:msg $n $cth(82hg)
        return
    }
    set t [split $t]    
    if {[llength $t] < 3} {
        mc:msg $n [format $cth(82hf) [join [lindex $poll 2]]]
        return
    }
    set pollansw [lindex $t 2]
    if {![isnumber $pollansw] || ($pollansw != 1 && $pollansw != 2 && $pollansw != 3)} {
        mc:msg $n [format $cth(82hf) [join [lindex $poll 2]]]
        return
    }
    if {![array exists pollanswers]} { set pollanswers(0) "" }
    if {[info exists pollanswers($id)]} {
        mc:msg $n $cth(82hj)
        return
    }
    set idlvl [mc:modget $id 17]
    if {[lsearch -exact [lindex $poll 2] $idlvl] == -1} {
        mc:msg $n $cth(82hk)
        return        
    }
    set pollanswers($id) $pollansw
    switch $pollansw {
        1 { mc:msg $n [format $cth(82hl) [ms:dfl [lindex $poll 0]]] }
        2 { mc:msg $n [format $cth(82hm) [ms:dfl [lindex $poll 0]]] }
        3 { mc:msg $n [format $cth(82hn) [ms:dfl [lindex $poll 0]]] }
    }
}

#  
proc mc:pollanounce {} {
    global poll cth mc pollanswers announcedur

    if {![info exists poll] || [lindex $poll 0] == ""} { return }

    mc:notice $mc(chan) [format $cth(82hr) [ms:dfl [lindex $poll 0]] [expr [array size pollanswers] - 1]]
    set polllevels [lindex $poll 2]
    if {[llength $polllevels] == 10} {
       mc:notice $mc(chan) [format $cth(82hf) ""]
    } elseif {[llength $polllevels] > 6} {
      set except_levels ""
      foreach single_number "1 2 3 4 5 6 7 8 9 10" {
          if {[lsearch -exact $polllevels $single_number] == -1} {
              set except_levels [lappend except_levels $single_number]
          }
      }       
      mc:notice $mc(chan) [format $cth(82hf_) [join $except_levels]]
    } else {
       mc:notice $mc(chan) [format $cth(82hf) [join $polllevels]]
    }
    utimer $announcedur { mc:pollanounce }
}

#  
proc mc:pollresults {} {
    global poll cth mc
    global pollanswers
    
    if {![info exists poll] || [lindex $poll 0] == ""} { return }
    if {![array exists pollanswers] || [array size pollanswers] < 1} {
        mc:notice $mc(chan) [format $cth(82ho) [ms:dfl [lindex $poll 0]]]
        return
    }
    set answfor 0
    set answnotfor 0
    set answabs 0
    set pollduration [expr (([clock seconds] - [lindex $poll 3]) / 60) + 1]
    set pollpeople [expr [array size pollanswers] - 1]
    #    
    if {[lindex $poll 1] == 2} {
        foreach poller [array names pollanswers] {
            if {$pollanswers($poller) == 1} { set answfor [expr $answfor + [mc:modget $poller 17]] 
            } elseif {$pollanswers($poller) == 2} { set answnotfor [expr $answnotfor + [mc:modget $poller 17]] 
            } elseif {$pollanswers($poller) == 3} { set answabs [expr $answabs + [mc:modget $poller 17]] }
        }
        mc:notice $mc(chan) [format $cth(82hq) $pollduration $pollpeople $answfor $answnotfor $answabs ""]
    #   
    } else {
        foreach poller [array names pollanswers] {
            if {$pollanswers($poller) == 1} { incr answfor 
            } elseif {$pollanswers($poller) == 2} { incr answnotfor 
            } elseif {$pollanswers($poller) == 3} { incr answabs }
        }
        mc:notice $mc(chan) [format $cth(82hq) $pollduration $pollpeople $answfor $answnotfor $answabs " "]
    }
}
