

set channel "#fightworld"

set primary(botname) "fight"
set primary(network) "Ircnet"

set slave(botname) "true"
set slave(network) "WeNet"

bind    link    -   *              slave:link
bind    disc    -   *              slave:disc
bind    bot     -   eval           slave:bot
bind    bot     -   trueeval       slave:eval

proc slave:putprimarybot {message} {
    global primary
        
    if {[islinked $primary(botname)]} {
        regsub -all "" $message "!9" message
        putbot $primary(botname) "slave $message"
    }
}

proc slave:sendnotice {subject notice} {
    putserv "NOTICE $subject :$notice"
}

proc slave:sendmsg {subject message} {
    putserv "PRIVMSG $subject :$message" }


proc slave:bot {botname command arguments} {
    global primary channel

    if {$botname == $primary(botname)} {
        if {[lindex $arguments 0] == "putserv" || [lindex $arguments 0] == "putquick" || [lindex $arguments 0] == "puthelp" || [lindex $arguments 0] == "pushmode"} {
            regsub -all "!9" $arguments "" arguments
            regsub -all "#&chan" $arguments $channel arguments
            regsub -all \\\\ $arguments "\\\\\\\\" arguments
            regsub -all \\\[ $arguments "\\\[" arguments
            regsub -all \\\] $arguments "\\\]" arguments
            regsub -all \\\^ $arguments "\\\^" arguments
            eval $arguments
        }
    }
}

proc slave:eval {botname command arguments} {
    global primary channel

    if {$botname == $primary(botname)} {
       regsub -all "!9" $arguments "" arguments
       regsub -all "#&chan" $arguments $channel arguments        
       eval $arguments
    }
}

proc slave:disc {botname} {   
    global primary channel
    
    if {$botname == $primary(botname)} {
        slave:sendnotice $channel "(system)      $primary(botname)@$primary(network)."
    }    
}

proc slave:link {botname via} {
    global primary slave channel

    if {$botname == $primary(botname) && $via == $slave(botname)} {
        slave:sendnotice $channel "(system)      $primary(botname)@$primary(network)."
    }
}

bind    msgm    -   *              slave:private
bind    pubm    -   "$channel *"   slave:public
bind    notc    -   *              slave:notice

proc slave:private {nick host handle text} {
    slave:putprimarybot "MSGM $nick $host $handle $text"
}

proc slave:public {nick host handle channel text} {
    slave:putprimarybot "PUBM $nick $host $handle $channel $text"
}

proc slave:notice {nick host handle text dest} {
    slave:putprimarybot "NOTC $nick $host $handle $text $dest"
}

proc slave:dcc {handle idx arg} {
    slave:putprimarybot "DCC $handle $idx $arg"
}

bind    join    -   "$channel *"   slave:join
bind    part    -   "$channel *"   slave:part
bind    sign    -   "$channel *"   slave:sign
bind    kick    -   "$channel *"   slave:kick
bind    nick    -   "$channel *"   slave:nick
bind    splt    -   "$channel *"   slave:splt
bind    rejn    -   "$channel *"   slave:rejn

proc slave:join {nick host handle channel} {
    slave:putprimarybot "JOIN $nick $host $handle $channel"
}

proc slave:part {nick host handle channel msg} {
    slave:putprimarybot "PART $nick $host $handle $channel $msg"
}

proc slave:sign {nick host handle channel reason} {
    slave:putprimarybot "SIGN $nick $host $handle $channel $reason"
}

proc slave:kick {nick host handle channel target reason} {
    slave:putprimarybot "KICK $nick $host $handle $channel $target $reason"
}

proc slave:nick {nick host handle channel newnick} {
    slave:putprimarybot "NICK $nick $host $handle $channel $newnick"
}

proc slave:splt {nick host handle channel} {
    slave:putprimarybot "SPLT $nick $host $handle $channel"
}

proc slave:rejn {nick host handle channel} {
    slave:putprimarybot "REJN $nick $host $handle $channel"
}


